long*ibranch_add(unsigned long);
void ibranch_done(unsigned long);
long*jumpforwardif_resolve(unsigned long,unsigned short);
long*jumpforward_resolve(unsigned long,unsigned short);
void jumpbackward_resolved(unsigned long,unsigned long,unsigned char,unsigned long);
void jumpbackward_resolve(unsigned long,unsigned short,unsigned char);
void jumpforwards_frame_done(unsigned long);
void jumpforwards_done(long*,long*);
void function_resolved(unsigned long,unsigned long,unsigned long);
#include "common.h"
long*branch_init(long,long);
//
//
//
long*     ibranch_add(unsigned long pf){
	unsigned long bra;bra=(long)((struct preframe*)pf)->branchpointer;
	unsigned char ok;
	ok=(long)re_alloc(&((struct branch*)bra)->innerbranches,((struct branch*)bra)->isize);
	if(ok==EXIT_SUCCESS){
		unsigned long* pointer;pointer=(long)((struct branch*)bra)->innerbranches;
		pointer=(long)pointer+(long)((struct branch*)bra)->isize;
		pointer[0]=(long)branch_init(pf,bra);//no suprabranch, same as root
		if(pointer[0]!=NULL){
			((struct branch*)bra)->isize=(long)((struct branch*)bra)->isize+(long)sizeof(long);
			return EXIT_SUCCESS;
		};
	};
	return EXIT_FAILURE;
};
void      ibranch_done(unsigned long pf){
	unsigned long bra;bra=(long)((struct preframe*)pf)->branchpointer;
	((struct preframe*)pf)->branchpointer=(long)((struct branch*)bra)->topbranch;
};
long*     jumpforwardif_resolve(unsigned long pf,unsigned short number){
	unsigned int offset;offset=(long)((struct preframe*)pf)->size;
	offset=(long)offset-(long)number;
	unsigned long prev;prev=(long)((struct preframe*)pf)->branchpointer;
	while(1){
		unsigned char ok;
		if(((struct branch*)prev)->offset==offset){//#is /,,+offset/
			ok=(long)re_alloc_add(&((struct preframe*)pf)->actions_if,&((struct preframe*)pf)->actions_if_size,((struct branch*)prev)->action_if);
			return ok;
		};
		//for forin break ends
		if(((struct branch*)prev)->offset_break==offset){
			ok=(long)re_alloc_add(&((struct preframe*)pf)->actions_if,&((struct preframe*)pf)->actions_if_size,((struct branch*)prev)->action_break);
			return ok;
		};
		prev=(long)((struct branch*)prev)->suprabranch;
	};
};
long*     jumpforward_resolve(unsigned long pf,unsigned short number){
	unsigned int offset;offset=(long)((struct preframe*)pf)->size;
	offset=(long)offset-(long)number;
	unsigned long prev;prev=(long)((struct preframe*)pf)->branchpointer;
	while(1){
		unsigned char ok;
		//for conditions end, this will resolve also break ends
		if(((struct branch*)prev)->offset==offset){//#is /,,&offset/
			ok=(long)re_alloc_add(&((struct preframe*)pf)->actions_jump,&((struct preframe*)pf)->actions_jump_size,((struct branch*)prev)->action_if);
			return ok;
		};
		//this is catching unreachable code after break end
		if(((struct branch*)prev)->offset_break==offset){//#both on first? like If? whiletrue break var a} but this is not logical
			printe("unreachable code after break");
			return EXIT_FAILURE;
		};
		prev=(long)((struct branch*)prev)->suprabranch;
	};
};
void      jumpbackward_resolved(unsigned long dest,unsigned long src,unsigned char log,unsigned long br){
	((struct action*)dest)->next=(long)src;
	if(log==TRUE){
		((struct branch*)br)->log_backjumps++;
	};
};
void      jumpbackward_resolve(unsigned long pf,unsigned short number,unsigned char log){
	unsigned int offset;offset=(long)((struct preframe*)pf)->size;
	offset=(long)offset-(long)number;
	unsigned long prev;prev=(long)((struct preframe*)pf)->branchpointer;
	while(1){
		if(((struct branch*)prev)->offset_loop==offset){//#can be ,,|,,$
			//link prev action to loop start action
			jumpbackward_resolved(((struct preframe*)pf)->action_last,((struct branch*)prev)->action_loop,log,prev);
			break;
		};
		prev=(long)((struct branch*)prev)->suprabranch;
	};
};
void      jumpforwards_frame_done(unsigned long prefr){
	if(prefr!=NULL){//else is from_show / no aframe
		unsigned long* pointer;unsigned long* end;
		unsigned long act;
		if(((struct preframe*)prefr)->actions_if_size!=0){
			pointer=(long)((struct preframe*)prefr)->actions_if;
			end=(long)pointer;
			end=(long)end+(long)((struct preframe*)prefr)->actions_if_size;
			while(pointer!=end){
				act=(long)pointer[0];
				((struct action*)act)->flags=(long)((struct action*)act)->flags|(long)if_flag;
				pointer++;
			};
		};
		if(((struct preframe*)prefr)->actions_jump_size!=0){
			pointer=(long)((struct preframe*)prefr)->actions_jump;
			end=(long)pointer;
			end=(long)end+(long)((struct preframe*)prefr)->actions_jump_size;
			unsigned char log;log=(long)global_blog();
			if(log==TRUE){
				unsigned long branch_item;branch_item=(long)((struct preframe*)prefr)->branchpointer;
				while(pointer!=end){
					act=(long)pointer[0];
					((struct action*)act)->next=(long)action_next_default;
					((struct branch*)branch_item)->log_fwdjumps++;
					pointer++;
				};
			}else{
				while(pointer!=end){
					act=(long)pointer[0];
					((struct action*)act)->next=(long)action_next_default;
					pointer++;
				};
			};
		};
	};
};
void      jumpforwards_done(long* presprites,long* prespr){//id will be word*4
	prespr=(long)prespr*(long)sizeof(long);
	prespr=(long)prespr+(long)presprites;
	prespr=(long)prespr[0];
	jumpforwards_frame_done(((struct presprite*)prespr)->apreframe);
	unsigned long* pointer;pointer=(long)((struct presprite*)prespr)->preframes;
	unsigned long end;end=(long)pointer;
	end=(long)end+(long)((struct presprite*)prespr)->size;
	while(pointer!=end){
		jumpforwards_frame_done(pointer[0]);
		pointer=(long)pointer+(long)sizeof(long);
	};
};
void      function_resolved(unsigned long data,unsigned long actions,unsigned long logpreframe){
	unsigned long* pointer;
	pointer=(long)((struct oadata*)data)->functions;
	pointer=(long)pointer+(long)((struct oadata*)data)->functions_size;
	pointer--;
	pointer[0]=(long)actions;
	if(logpreframe!=NULL){
		((struct preframe*)logpreframe)->log_sizedfunctions++;
	};
};
