long*string_add(long*,long*,unsigned long,unsigned char,int*,unsigned char);
void indent();
void printn(long*);
void print_inline_done();
void printt(unsigned char*);
void print_indent();
void print_unindent();
void print(unsigned char*,unsigned long);
void prints(unsigned char*);
void prints_inline_start(unsigned char*);
void print_inline_start(unsigned char*,unsigned long);
void print_einline(unsigned char*,unsigned int);
void prints_inline(unsigned char*);
void print_text(unsigned char*,unsigned long);
void printe(unsigned char*);
void print_hex_start(unsigned char*,unsigned int);
void print_hhex(unsigned char*,unsigned short);
void print_hex(unsigned char*,unsigned int);
void print_lhex(unsigned char*,unsigned long);
void string_log(unsigned long,unsigned long);
long*string_id(unsigned long,unsigned short*,int*,unsigned char);
#include "common.h"
//multithread unsafe
unsigned char indents=0;
//
//
long*platform_stdout();
//
long*memnl(long,long);
//
long*platform_stderr();
//
#define ui8max_ 256
//                            # is xlog_new_size
long*     string_add(long* pf,long* p_string_off,unsigned long strings_base,unsigned char type,int* _recalculation,unsigned char inlogtype){
	unsigned char ok;
	unsigned long str;long* dest;
	if(type==xlog_new){
		ok=(long)re_alloc(&((struct preframe*)pf)->strings,((struct preframe*)pf)->ssize);
		if(ok==EXIT_SUCCESS){
			str=(long)malloc(sizeof(struct string));
			if(str!=NULL){
				unsigned long branches;
				branches=(long)malloc(sprites_realloc_onepart);
				if(branches==NULL){
					free(str);
					return EXIT_FAILURE;
				};
				((struct string*)str)->branches=(long)branches;
				((struct string*)str)->size=(long)0;
				((struct string*)str)->base=(long)strings_base;//in two steps for log.
				((struct string*)str)->off=(long)p_string_off[0];
				if(_recalculation!=NULL){
					if(inlogtype==xlog_const16_log){//index can be lower in final
						unsigned int items;items=(long)((struct preframe*)pf)->ssize;
						items=(unsigned long)items/(long)sizeof(long);
						if((unsigned long)items<(unsigned long)ui8max_){
							_recalculation[0]--;
						};
					};
				};
				dest=(long)((struct preframe*)pf)->strings;
				dest=(long)dest+(long)((struct preframe*)pf)->ssize;
				dest[0]=(long)str;
				((struct preframe*)pf)->ssize=(long)((struct preframe*)pf)->ssize+(long)sizeof(long);
				return EXIT_SUCCESS;
			};
		};
	}else{//xlog_unique
		ok=(long)re_alloc(&((struct preframe*)pf)->ustrings,((struct preframe*)pf)->ussize);
		if(ok==EXIT_SUCCESS){
			str=(long)malloc(sizeof(struct ustring));
			if(str!=NULL){
				((struct ustring*)str)->base=(long)strings_base;//in two steps for log.
				((struct ustring*)str)->off=(long)p_string_off[0];
				((struct ustring*)str)->ubranch=(long)((struct preframe*)pf)->branchpointer;
				if(_recalculation!=NULL){
					strings_base=(long)strings_base+(long)p_string_off[0];
					_recalculation[0]=(long)_recalculation[0]+(long)strlen(strings_base);
					if(inlogtype==xlog_const16_log){//
						_recalculation[0]--;
					};
				};
				dest=(long)((struct preframe*)pf)->ustrings;
				dest=(long)dest+(long)((struct preframe*)pf)->ussize;
				dest[0]=(long)str;
				((struct preframe*)pf)->ussize=(long)((struct preframe*)pf)->ussize+(long)sizeof(long);
				return EXIT_SUCCESS;
			};
		};
	};
	return EXIT_FAILURE;
};
void      indent(){
	unsigned char i;
	i=(long)indents;
	while(i>0){
		putchar(Tab);
		i--;
	};
};
void      printn(long* s){
	fputc(output_nl,s);
};
void      print_inline_done(){
	unsigned long so;so=(long)platform_stdout();
	printn(so);
};
void      printt(unsigned char* str){
	unsigned long so;so=(long)platform_stdout();
	fputs(str,so);
};
void      print_indent(){
	indents++;
};
void      print_unindent(){
	indents--;
};
void      print(unsigned char* format,unsigned long value){
	indent();
	printf(format,value);
	print_inline_done();
};
void      prints(unsigned char* format){
	indent();
	printt(format);
	print_inline_done();
};
void      prints_inline_start(unsigned char* str){
	indent();
	printt(str);
};
void      print_inline_start(unsigned char* format,unsigned long value){
	indent();
	printf(format,value);
};
void      print_einline(unsigned char* format,unsigned int value){
	putchar(Space);
	printt(format);
	putchar(Equal);
	printf("%u",value);
};
void      prints_inline(unsigned char* format){
	putchar(Space);
	printt(format);
};
void      print_text(unsigned char* a,unsigned long c){
	unsigned long so;so=(long)platform_stdout();
	unsigned char* b;
	unsigned long d;
	c=(long)c+(long)a;
	while(a!=c){
		d=(long)memnl(a,&b);//more in the function, \r\n example
		if(d!=a){//why to write a whitespaces row?
			d=(long)d-(long)a;
			indent();
			fwrite(a,d,1,so);
			print_inline_done();
		};
		a=(long)b;
	};
};
void      printe(unsigned char* er){
	unsigned long se;se=(long)platform_stderr();
	fputs(er,se);
	printn(se);
};
void      print_hex_start(unsigned char* front,unsigned int value){
	printf("%s=0x%X",front,value);
};
void      print_hhex(unsigned char* front,unsigned short value){
	putchar(Space);
	printf("%s=0x%hX",front,value);
};
void      print_hex(unsigned char* front,unsigned int value){
	putchar(Space);
	print_hex_start(front,value);
};
void      print_lhex(unsigned char* front,unsigned long value){
	putchar(Space);
	printf("%s=0x%lX",front,value);
};
void      string_log(unsigned long base,unsigned long off){
	base=(long)base+(long)off;
	off++;//to log like in .x where 0 is NULL and 1 is offset 0
	print_lhex(base,off);//will recognize the branch (visual) when having the string -> branch link and the branch offset
};
long*     string_id(unsigned long prefr,unsigned short* xxcontent,int* _recalculation,unsigned char inlogtype){
	unsigned short id;id=(long)xxcontent[0];
	if(_recalculation!=NULL){
		if(inlogtype==xlog_const16_log){//same
			if((unsigned long)id<(unsigned long)ui8max_){
				_recalculation[0]--;
			};
		};
	};
	long* str=sizeof(long);
	str=(long)str*(long)id;
	str=(long)str+(long)((struct preframe*)prefr)->strings;
	str=(long)str[0];
	unsigned long current_branch;current_branch=(long)((struct preframe*)prefr)->branchpointer;
	unsigned long start;start=(long)((struct string*)str)->branches;
	unsigned long* pointer;pointer=(long)start;
	pointer=(long)pointer+(long)((struct string*)str)->size;
	while(start!=pointer){
		pointer=(long)pointer-(long)sizeof(long);
		if(pointer[0]==current_branch){
			return EXIT_SUCCESS;//is on same branch, same cut if first match, else on another cut
		};
	};
	unsigned char ok;
	ok=(long)re_alloc_add(&((struct string*)str)->branches,&((struct string*)str)->size,current_branch);
	return ok;
};

