long*branch_init(unsigned long,unsigned long,unsigned long);
long*branch_add(long*,unsigned int,unsigned int,unsigned long);
void branch_code(unsigned char*,unsigned long,unsigned char*,unsigned char*,unsigned char*);
void branch_log(long*,unsigned long);
void branch_free(unsigned long,unsigned long,unsigned int);
#include "common.h"
//
//
//
//
//branch pointer
long*     branch_init(unsigned long pf,unsigned long ptbra,unsigned long pbra){//3
	unsigned long bra;
	bra=(long)malloc(sizeof(struct branch));
	if(bra!=NULL){
		unsigned long inners;
		inners=(long)malloc(sprites_realloc_onepart);
		if(inners!=NULL){
			long* cuts;cuts=(long)malloc(1);//symbolic, null malloc can be null return
			if(cuts!=NULL){
				((struct branch*)bra)->cuts=(long)cuts;
				((struct branch*)bra)->size=(long)0;
				((struct branch*)bra)->innerbranches=(long)inners;
				((struct branch*)bra)->isize=(long)0;
				((struct preframe*)pf)->branchpointer=(long)bra;
				((struct branch*)bra)->topbranch=(long)ptbra;
				((struct branch*)bra)->suprabranch=(long)pbra;
				((struct branch*)bra)->subbranch=(long)NULL;
				((struct branch*)bra)->offset=(long)((struct preframe*)pf)->size;
				((struct branch*)bra)->offset_loop=(long)no_loop;
				((struct branch*)bra)->offset_break=(long)no_loop;
				((struct branch*)bra)->action_top=(long)NULL;//#normaly branch.size!=0 but that implies pointer_to_action and that will not work between action calls
				unsigned char blog;blog=(long)global_blog();
				if(blog==TRUE){
					((struct preframe*)pf)->log_branchid++;
					((struct branch*)bra)->log_id=(long)((struct preframe*)pf)->log_branchid;
					((struct branch*)bra)->log_fn=(long)0;
					((struct branch*)bra)->log_backjumps=(long)0;
					((struct branch*)bra)->log_fwdjumps=(long)0;
				};
				return bra;
			};
			free(inners);
		};
		free(bra);
	};
	return NULL;
};
long*     branch_add(long* pf,unsigned int size,unsigned int offset,unsigned long code){
	size=(long)size-(long)offset;
	long* br;br=(long)((struct preframe*)pf)->branchpointer;
	unsigned long sz;sz=(long)((struct branch*)br)->size;
	sz=(long)sz+(long)sizeof(struct branchcut);
	unsigned long mem;mem=(long)realloc(((struct branch*)br)->cuts,sz);
	if(mem!=NULL){
		((struct branch*)br)->cuts=(long)mem;
		mem=(long)mem+(long)sz;
		mem=(long)mem-(long)sizeof(struct branchcut);
		((struct branchcut*)mem)->x=(long)code;
		((struct branchcut*)mem)->size=(long)size;
		((struct branch*)br)->size=(long)sz;
		return EXIT_SUCCESS;
	};
	return EXIT_FAILURE;
};
void      branch_code(unsigned char* code,unsigned long end,unsigned char* _a,unsigned char* _b,unsigned char* form){
	unsigned char* start;start=(long)code;
	unsigned char a;unsigned char b;
	a=(long)_a[0];b=(long)_b[0];
	end=(long)end+(long)code;
	while(code!=end){
		//best view command is same as in src/x.oc debug_x_pad
		if(b==0){
			if(a==0){
				if(start!=NULL){
					print_inline_start(form,code[0]);
				}else{
					prints_inline_start(form);
				};
				a++;b++;code++;
				continue;
			};
		};
		if(a<4){
			if(start!=NULL){
				printf(form,code[0]);
			}else{
				printt(form);
			};
			a++;
		}else if(b<12){
			if(start!=NULL){
				putchar(Space);
				printf(form,code[0]);
			}else{
				prints_inline(form);
			};
			a=(long)1;b++;
		}else{
			print_inline_done();
			a=(long)0;b=(long)0;
			continue;
		};
		code++;
	};
	_a[0]=(long)a;_b[0]=(long)b;
};
void      branch_log(long* br,unsigned long start){
	prints_inline_start("branch:");
	unsigned long cuts;cuts=(long)((struct branch*)br)->cuts;
	unsigned long end;end=(long)cuts;
	unsigned long size;size=(long)0;// same like in branch.size comment
	//long long on 32? is not the case, more at save_branch
	end=(long)end+(long)((struct branch*)br)->size;
	while(cuts!=end){
		size=(long)size+(long)((struct branchcut*)cuts)->size;
		cuts=(long)cuts+(long)sizeof(struct branchcut);
	};
	print_einline("id",((struct branch*)br)->log_id);
	print_lhex("size",size);
	unsigned int sz;sz=(long)((struct branch*)br)->isize;
	if(sz!=0){//most of the cases, it is best that only root has functions
		sz=(long)sz/(long)sizeof(long);
		print_einline("inners",sz);
	};
	print_hex("aoffset",((struct branch*)br)->offset);
	if(((struct branch*)br)->offset_loop!=no_loop){
		print_hex("aoffset_loop",((struct branch*)br)->offset_loop);
	};
	if(((struct branch*)br)->offset_break!=no_loop){
		print_hex("aoffset_break",((struct branch*)br)->offset_break);
	};
	if(((struct branch*)br)->log_fn!=0){
		print_hhex("afsize",((struct branch*)br)->log_fn);
	};
	if(((struct branch*)br)->log_backjumps!=0){
		print_einline("bjump",((struct branch*)br)->log_backjumps);
	};
	if(((struct branch*)br)->log_fwdjumps!=0){
		print_einline("fjump",((struct branch*)br)->log_fwdjumps);
	};
	prints_inline("code:");
	print_inline_done();
	print_indent();
	cuts=(long)((struct branch*)br)->cuts;
	while(cuts!=end){
		unsigned char* code;code=(long)((struct branchcut*)cuts)->x;
		sz=(long)((struct branchcut*)cuts)->size;//same minimum like in save save_branch
		unsigned char pad;pad=(long)oadata_logpad_get();
		//charx pad_minus_one#256-1 #was xlog_pad_default
		//	#for branches with holes(like a function def there) a full 48 row is required
		//	#here is the initial pad, that can be full row - 4 bytes. but if not padded can be - 1 byte, then, 47
		unsigned long pad_sz;pad_sz=(long)code;
		pad_sz=(long)pad_sz-(long)start;
		unsigned int strip_pad_sz;strip_pad_sz=(long)pad_sz;
		strip_pad_sz=(unsigned long)strip_pad_sz/(long)pad;
		strip_pad_sz=(long)strip_pad_sz*(long)pad;
		pad_sz=(long)pad_sz-(long)strip_pad_sz;
		unsigned char a;unsigned char b;
		a=(long)0;b=(long)0;
		branch_code(NULL,pad_sz,&a,&b,"..");
		branch_code(code,sz,&a,&b,"%02X");
		print_inline_done();
		cuts=(long)cuts+(long)sizeof(struct branchcut);
	};
	print_unindent();
};
void      branch_free(unsigned long br,unsigned long logstart,unsigned int indents){
	if(logstart!=NULL){
		branch_log(br,logstart);
	};
	free(((struct branch*)br)->cuts);
	unsigned long* pointer;pointer=(long)((struct branch*)br)->innerbranches;
	unsigned long end;end=(long)pointer;
	end=(long)end+(long)((struct branch*)br)->isize;
	while(pointer!=end){
		if(logstart!=NULL){
			tree_entrylive(indents,xlog_innerbranch);
			indents++;
		};
		branch_free(pointer[0],logstart,indents);
		if(logstart!=NULL){
			indents--;
			tree_entrylive(indents,xlog_innerbranchend);
		};
		pointer=(long)pointer+(long)sizeof(long);
	};
	free(((struct branch*)br)->innerbranches);
	if(((struct branch*)br)->subbranch!=NULL){
		if(logstart!=NULL){
			tree_entrylive(indents,xlog_branch);
		};
		branch_free(((struct branch*)br)->subbranch,logstart,indents);
	};
	free(br);
};
