long*mark_all(unsigned long*,unsigned long,unsigned long);
long*mark_presprite(unsigned long,unsigned long);
long*mark_branch(unsigned long,unsigned long);
long*mark_action_if(unsigned long,unsigned long);
long*mark_action(unsigned long,unsigned long);
long*mark_string_branch(unsigned long,unsigned long);
long*mark_string_branches(unsigned long,unsigned long);
long*mark_compare(unsigned long,unsigned long*,unsigned int,unsigned long);
long*mark_compare_frame(unsigned long,unsigned long,unsigned long);
long*mark_compare_branch(unsigned long,unsigned long,unsigned long);
long*mark_compare_string(unsigned long,unsigned long);
#include "common.h"
//
//
long*     mark_all(unsigned long* presprites,unsigned long end,unsigned long data){
	unsigned char ok;
	end=(long)end+(long)presprites;
	while(presprites!=end){
		if(presprites[0]!=NULL){//here can have other tags, the map order is important when debugging
			ok=(long)mark_presprite(presprites[0],data);
			if(ok!=EXIT_SUCCESS){
				return EXIT_FAILURE;
			};
		};
		presprites++;
	};
	return EXIT_SUCCESS;
};
long*     mark_presprite(unsigned long ps,unsigned long data){
	unsigned char ok;
	unsigned long fr;
	if(((struct presprite*)ps)->apreframe!=NULL){
		fr=(long)((struct presprite*)ps)->apreframe;
		ok=(long)mark_branch(((struct preframe*)fr)->abranch,data);
		if(ok==EXIT_FAILURE){
			return EXIT_FAILURE;
		};
	};
	unsigned long* frames;frames=(long)((struct presprite*)ps)->preframes;
	unsigned long fend;fend=(long)frames;
	fend=(long)fend+(long)((struct presprite*)ps)->size;
	while(frames!=fend){
		if(frames[0]!=NULL){//also with shows
			fr=(long)frames[0];
			ok=(long)mark_branch(((struct preframe*)fr)->abranch,data);
			if(ok==EXIT_FAILURE){
				return EXIT_FAILURE;
			};
		};
		frames++;
	};
	return EXIT_SUCCESS;
};
long*     mark_branch(unsigned long br,unsigned long data){
	unsigned char ok;ok=(long)mark_action_if(((struct branch*)br)->action_top,data);
	if(ok==EXIT_SUCCESS){
		unsigned long* ibrs;ibrs=(long)((struct branch*)br)->innerbranches;
		unsigned long end;end=(long)ibrs;
		end=(long)end+(long)((struct branch*)br)->isize;
		while(ibrs!=end){
			ok=(long)mark_branch(ibrs[0],data);
			if(ok==EXIT_FAILURE){
				return EXIT_FAILURE;
			};
			ibrs++;
		};
		if(((struct branch*)br)->subbranch!=NULL){
			ok=(long)mark_branch(((struct branch*)br)->subbranch,data);
			if(ok==EXIT_FAILURE){
				return EXIT_FAILURE;
			};
		};
		return EXIT_SUCCESS;
	};
	return EXIT_FAILURE;
};
long*     mark_action_if(unsigned long act,unsigned long data){
	if(act!=NULL){//can be trick branch, while(true){break} , then has subbranches with actions
		unsigned char ok;ok=(long)mark_action(act,data);
		return ok;
	};
	return EXIT_SUCCESS;
};
long*     mark_action(unsigned long act,unsigned long data){
	unsigned long size;size=(long)((struct oadata*)data)->size;
	unsigned long ix;ix=(long)size;
	unsigned long index;index=(long)ix;
	size=(long)size+(long)sizeof(struct mark);
	unsigned long* marks;marks=(long)realloc(((struct oadata*)data)->marks,size);
	if(marks!=NULL){
		((struct oadata*)data)->marks=(long)marks;
		((struct oadata*)data)->size=(long)size;
		index=(long)index/(long)sizeof(struct mark);
		((struct action*)act)->amark=(long)index;
		ix=(long)ix+(long)marks;
		if(ix==marks){
			((struct mark*)ix)->prev=(long)mark_nothing;
			((struct mark*)ix)->next=(long)mark_nothing;
		}else{
			((struct mark*)ix)->next=(long)mark_nothing;
			size=(long)size/(long)sizeof(struct mark);
			size--;
			((struct mark*)ix)->prev=(long)size;
			((struct mark*)ix)->prev--;
			ix=(long)ix-(long)sizeof(struct mark);
			((struct mark*)ix)->next=(long)size;
		};
		return EXIT_SUCCESS;
	};
	return EXIT_FAILURE;
};
long*     mark_string_branch(unsigned long br,unsigned long data){
	unsigned long act;act=(long)((struct branch*)br)->action_top;
	if(((struct action*)act)->amark==mark_nothing){//was already marked at another previous branch
		unsigned char ok;ok=(long)mark_action(act,data);
		return ok;
	};
	return EXIT_SUCCESS;
};
long*     mark_string_branches(unsigned long str,unsigned long data){
	unsigned long* brs;unsigned long brsend;unsigned char ok;
	brs=(long)((struct string*)str)->branches;
	brsend=(long)brs;brsend=(long)brsend+(long)((struct string*)str)->size;
	while(brs!=brsend){
		ok=(long)mark_string_branch(brs[0],data);
		if(ok!=EXIT_SUCCESS){
			return EXIT_FAILURE;
		};
		brs++;
	};
	return EXIT_SUCCESS;
};
long*     mark_compare(unsigned long prevoadata,unsigned long* presprites,unsigned int size,unsigned long data){
	unsigned long* prevpresprites;prevpresprites=(long)((struct preoadata*)prevoadata)->presprites;
	unsigned long prevend;prevend=(long)prevpresprites;prevend=(long)prevend+(long)((struct preoadata*)prevoadata)->size;
	unsigned long end;end=(long)presprites;
	end=(long)end+(long)size;
	while(presprites!=end){
		if(presprites[0]!=NULL){//from parsed where the map to oadata out was
			unsigned char ok;
			unsigned long pvps;
			if(prevpresprites!=prevend){
				pvps=(long)prevpresprites[0];
				unsigned long ps;ps=(long)presprites[0];
				unsigned long fr;
				if(((struct presprite*)ps)->apreframe!=NULL){
					if(((struct presprite*)pvps)->apreframe!=NULL){
						ok=(long)mark_compare_frame(((struct presprite*)pvps)->apreframe,((struct presprite*)ps)->apreframe,data);
					}else{
						fr=(long)((struct presprite*)ps)->apreframe;
						ok=(long)mark_branch(((struct preframe*)fr)->abranch,data);
					};
					if(ok!=EXIT_SUCCESS){
						return EXIT_FAILURE;
					};
				};
				unsigned long* prevfrs;prevfrs=(long)((struct presprite*)pvps)->preframes;
				unsigned long prevfend;prevfend=(long)prevfrs;prevfend=(long)prevfend+(long)((struct presprite*)pvps)->size;
				unsigned long* frs;frs=(long)((struct presprite*)ps)->preframes;
				unsigned long fend;fend=(long)frs;
				fend=(long)fend+(long)((struct presprite*)ps)->size;
				while(frs!=fend){
					if(prevfrs!=prevfend){
						if(frs[0]!=NULL){//shows
							ok=(long)mark_compare_frame(prevfrs[0],frs[0],data);
						};
						prevfrs++;
					}else if(frs[0]!=NULL){//shows
						fr=(long)frs[0];
						ok=(long)mark_branch(((struct preframe*)fr)->abranch,data);
					};
					if(ok!=EXIT_SUCCESS){
						return EXIT_FAILURE;
					};
					frs++;
				};
				prevpresprites++;
			}else{
				ok=(long)mark_presprite(presprites[0],data);
				if(ok!=EXIT_SUCCESS){
					return EXIT_FAILURE;
				};
			};
		};
		presprites++;
	};
	return EXIT_SUCCESS;
};
long*     mark_compare_frame(unsigned long prevpf,unsigned long pf,unsigned long data){
	unsigned char ok;
	ok=(long)mark_compare_branch(((struct preframe*)prevpf)->abranch,((struct preframe*)pf)->abranch,data);//compare branch
	if(ok==EXIT_SUCCESS){//strings are last because if where first then will ask for action.amark not mark_nothing at cuts
		unsigned long* strs;unsigned long end;unsigned long* prevstrs;unsigned long prevend;unsigned long str;int cmp;
		//compare ustrings, prev, action.amark!=mark_nothing and then same like strings, and then mark_action
		prevstrs=(long)((struct preframe*)prevpf)->ustrings;
		prevend=(long)prevstrs;prevend=(long)prevend+(long)((struct preframe*)prevpf)->ussize;
		strs=(long)((struct preframe*)pf)->ustrings;
		end=(long)strs;end=(long)end+(long)((struct preframe*)pf)->ussize;
		while(strs!=end){
			str=(long)strs[0];
			if(prevstrs!=prevend){
				cmp=(long)mark_compare_string(prevstrs[0],str);
				if(cmp!=0){
					//restored string has no branches, that diff is observable at cuts
					ok=(long)mark_string_branch(((struct ustring*)str)->ubranch,data);
					if(ok!=EXIT_SUCCESS){
						return EXIT_FAILURE;
					};
				};
				prevstrs++;
			}else{
				ok=(long)mark_string_branch(((struct ustring*)str)->ubranch,data);
				if(ok!=EXIT_SUCCESS){
					return EXIT_FAILURE;
				};
			};
			strs++;
		};
		//compare strings, prev, here compare string first(strings without knowing null end) then branches action.amark!=mark_nothing, and then mark_action
		prevstrs=(long)((struct preframe*)prevpf)->strings;
		prevend=(long)prevstrs;prevend=(long)prevend+(long)((struct preframe*)prevpf)->ssize;
		strs=(long)((struct preframe*)pf)->strings;
		end=(long)strs;end=(long)end+(long)((struct preframe*)pf)->ssize;
		while(strs!=end){
			str=(long)strs[0];
			if(prevstrs!=prevend){
				cmp=(long)mark_compare_string(prevstrs[0],str);
				if(cmp!=0){
					//restored string has no branches, that diff is observable at cuts
					ok=(long)mark_string_branches(str,data);
					if(ok!=EXIT_SUCCESS){
						return EXIT_FAILURE;
					};
				};
				prevstrs++;
			}else{
				ok=(long)mark_string_branches(str,data);
				if(ok!=EXIT_SUCCESS){
					return EXIT_FAILURE;
				};
			};
			strs++;
		};
	};
	return ok;
};
long*     mark_compare_branch(unsigned long prevbr,unsigned long br,unsigned long data){
	unsigned char ok;
	//compare cuts
	if(((struct branch*)prevbr)->size==((struct branch*)br)->size){
		unsigned long* prevcursor;unsigned long* cursor;unsigned long cutsend;
		prevcursor=(long)((struct branch*)prevbr)->cuts;
		cursor=(long)((struct branch*)br)->cuts;
		cutsend=(long)cursor;cutsend=(long)cutsend+(long)((struct branch*)br)->size;
		while(cursor!=cutsend){
			if(((struct branchcut*)prevcursor)->size==((struct branchcut*)cursor)->size){
				int cmp;cmp=(long)memcmp(((struct branchcut*)prevcursor)->x,((struct branchcut*)cursor)->x,((struct branchcut*)cursor)->size);
				if(cmp==0){
					cursor=(long)cursor+(long)sizeof(struct branchcut);
					prevcursor=(long)prevcursor+(long)sizeof(struct branchcut);
					continue;
				};
			};
			ok=(long)mark_action_if(((struct branch*)br)->action_top,data);
			if(ok!=EXIT_SUCCESS){
				return EXIT_FAILURE;
			};
			break;
		};
	}else{
		ok=(long)mark_action_if(((struct branch*)br)->action_top,data);//one case can be: prev with size, this no size
		if(ok!=EXIT_SUCCESS){
			return EXIT_FAILURE;
		};
	};
	//inners
	unsigned long* previns;previns=(long)((struct branch*)prevbr)->innerbranches;
	unsigned long prevend;prevend=(long)previns;prevend=(long)prevend+(long)((struct branch*)prevbr)->isize;
	unsigned long* ins;ins=(long)((struct branch*)br)->innerbranches;
	unsigned long end;end=(long)ins;end=(long)end+(long)((struct branch*)br)->isize;
	while(ins!=end){
		if(previns!=prevend){
			ok=(long)mark_compare_branch(previns[0],ins[0],data);
			previns++;
		}else{
			ok=(long)mark_branch(ins[0],data);
		};
		if(ok!=EXIT_SUCCESS){
			return EXIT_FAILURE;
		};
		ins++;
	};
	//subbranch
	if(((struct branch*)br)->subbranch!=NULL){
		if(((struct branch*)prevbr)->subbranch!=NULL){
			ok=(long)mark_compare_branch(((struct branch*)prevbr)->subbranch,((struct branch*)br)->subbranch,data);
		}else{
			ok=(long)mark_branch(((struct branch*)br)->subbranch,data);
		};
		return ok;
	};
	return EXIT_SUCCESS;
};
long*     mark_compare_string(unsigned long prevstr,unsigned long str){
	unsigned long s1;s1=(long)((struct ustring*)prevstr)->base;
	s1=(long)s1+(long)((struct ustring*)prevstr)->off;
	unsigned long s2;s2=(long)((struct ustring*)str)->base;
	s2=(long)s2+(long)((struct ustring*)str)->off;
	int cmp;cmp=(long)strcmp(s1,s2);
	return cmp;
};
