long*lowwrite(unsigned long,unsigned char,unsigned long);
long*mediumwrite(unsigned long,unsigned short,unsigned long);
long*highwrite(unsigned long,unsigned int,unsigned long);
long*swrite(unsigned short,unsigned long);
long*iwrite(unsigned int,unsigned long);
long*truewrite(unsigned long);
long*falsewrite(unsigned long);
long*save(unsigned long*,unsigned long);
long*save_frame(unsigned long,unsigned long);
long*save_strings(unsigned long*,unsigned long,unsigned long);
long*save_branch(unsigned long,unsigned long);
void lowread(unsigned long,unsigned long,unsigned char);
long*mediumread(unsigned long,unsigned short);
long*highread(unsigned long,unsigned int);
void cread(unsigned long,unsigned char*);
void sread(unsigned long,unsigned short*);
void iread(unsigned long,unsigned int*);
void restore_strings_free(unsigned long,unsigned long*,unsigned int);
void restore_branch_inners_free(unsigned long);
void restore_branch_cuts_free(unsigned long);
void restore_branch_free(unsigned long);
void restore_frame_free(unsigned long);
void restore_free(unsigned long*);
long*restore(unsigned long);
long*restore_frame(unsigned long);
long*restore_strings(unsigned long,unsigned long*,unsigned long*,int*);
long*restore_branch(unsigned long);
#include "common.h"
#define BYTE 1
#define WORD 2
#define DWORD 4
//
//
//
//
//
long*     lowwrite(unsigned long buf,unsigned char sz,unsigned long file){
	unsigned char out;out=(long)fwrite(buf,sz,1,file);
	return out;
};
long*     mediumwrite(unsigned long buf,unsigned short sz,unsigned long file){
	unsigned char out;out=(long)fwrite(buf,sz,1,file);
	return out;
};
long*     highwrite(unsigned long buf,unsigned int sz,unsigned long file){
	unsigned char out;out=(long)fwrite(buf,sz,1,file);
	return out;
};
long*     swrite(unsigned short n,unsigned long file){
	unsigned char out;out=(long)lowwrite(&n,WORD,file);//size_t but WORD write
	return out;
};
long*     iwrite(unsigned int n,unsigned long file){
	unsigned char out;out=(long)lowwrite(&n,DWORD,file);
	return out;
};
long*     truewrite(unsigned long file){
	unsigned char a=TRUE;
	unsigned char out;out=(long)lowwrite(&a,BYTE,file);
	return out;
};
long*     falsewrite(unsigned long file){
	unsigned char a=FALSE;
	unsigned char out;out=(long)lowwrite(&a,BYTE,file);
	return out;
};
long*     save(unsigned long* presprites,unsigned long file){
	unsigned long end;end=(long)presprites;
	end=(long)end+(long)global_presprites_size();
	unsigned short counted;counted=(long)0;
	long* pointer;pointer=(long)presprites;
	while(pointer!=end){
		if(pointer[0]!=NULL){
			counted++;
		};
		pointer++;
	};
	unsigned char out;out=(long)swrite(counted,file);
	if(out!=0){
		while(presprites!=end){
			unsigned long ps;ps=(long)presprites[0];
			if(ps!=NULL){
				if(((struct presprite*)ps)->apreframe!=NULL){
					out=(long)truewrite(file);
					if(out==0){
						return EXIT_FAILURE;
					};
					out=(long)save_frame(((struct presprite*)ps)->apreframe,file);
				}else{
					out=(long)falsewrite(file);
				};
				if(out==0){
					return EXIT_FAILURE;
				};
				unsigned int size;size=(long)((struct presprite*)ps)->size;
				size=(long)size-(long)sizeof(long);//1 is always only ready for next
				unsigned long fend;fend=(long)size;
				size=(long)size/(long)sizeof(long);
				out=(long)swrite(size,file);//store from_show places, next they can be with action and later one frame is unmodified, plus all gotoAnd places
				if(out!=0){
					unsigned long* frames;frames=(long)((struct presprite*)ps)->preframes;
					fend=(long)fend+(long)frames;
					while(frames!=fend){
						if(frames[0]!=NULL){
							out=(long)truewrite(file);
							if(out==0){
								return EXIT_FAILURE;
							};
							out=(long)save_frame(frames[0],file);
						}else{// from_show
							out=(long)falsewrite(file);
						};
						if(out==0){
							return EXIT_FAILURE;
						};
						frames++;
					};
				};
			};
			presprites++;
		};
		return EXIT_SUCCESS;
	};
	return EXIT_FAILURE;
};
long*     save_frame(unsigned long aframe,unsigned long file){
	unsigned char out;out=(long)save_strings(((struct preframe*)aframe)->ustrings,((struct preframe*)aframe)->ussize,file);
	if(out!=0){
		out=(long)save_strings(((struct preframe*)aframe)->strings,((struct preframe*)aframe)->ssize,file);
		if(out!=0){
			out=(long)save_branch(((struct preframe*)aframe)->abranch,file);
		};
	};
	return out;
};
long*     save_strings(unsigned long* pointer,unsigned long end,unsigned long file){
	unsigned long* strings;strings=(long)pointer;
	unsigned short size;size=(long)0;//string was in constantpool that is actionrecordheader with ui16 size
	end=(long)end+(long)pointer;
	unsigned long str;unsigned long text;
	while(pointer!=end){
		str=(long)pointer[0];
		text=(long)((struct string*)str)->base;
		text=(long)text+(long)((struct string*)str)->off;
		size=(long)size+(long)strlen(text);
		size++;//null end \0
		pointer++;
	};
	unsigned char out;out=(long)swrite(size,file);
	if(out!=0){
		while(strings!=end){
			str=(long)strings[0];
			text=(long)((struct string*)str)->base;
			text=(long)text+(long)((struct string*)str)->off;
			size=(long)strlen(text);
			size++;//null
			out=(long)mediumwrite(text,size,file);
			if(out==0){
				return 0;
			};
			strings++;
		};
	};
	return out;
};
long*     save_branch(unsigned long br,unsigned long file){//at least a mathend/function_marker/whileblock_end/if_marker here
	// branch_log. here we are gipsying because on 32 we are not agreeing with qword size. we are writing cuts sized parts
	//with this occasion: it is good that multiple action calls are not merged into a branch
	//anyway on 32src there are ftell calls .x at xcode start, at expands, overall at reread, that will enforce a small file
	unsigned long cuts;cuts=(long)((struct branch*)br)->cuts;
	unsigned long end;end=(long)cuts;
	end=(long)end+(long)((struct branch*)br)->size;
	unsigned char out;unsigned int sz;
	while(cuts!=end){
		sz=(long)((struct branchcut*)cuts)->size;
		out=(long)iwrite(sz,file);
		if(out==0){
			return 0;
		};
		unsigned long code;code=(long)((struct branchcut*)cuts)->x;
		out=(long)highwrite(code,sz,file);
		if(out==0){
			return 0;
		};
		cuts=(long)cuts+(long)sizeof(struct branchcut);
	};
	out=(long)iwrite(0,file);
	if(out!=0){
		sz=(long)((struct branch*)br)->isize;//expanded size
		end=(long)sz;
		sz=(unsigned long)sz/(long)sizeof(long);
		out=(long)iwrite(sz,file);
		if(out!=0){
			unsigned long* pointer;pointer=(long)((struct branch*)br)->innerbranches;
			end=(long)end+(long)pointer;
			while(pointer!=end){
				out=(long)save_branch(pointer[0],file);
				if(out==0){
					return 0;
				};
				pointer++;
			};
			pointer=(long)((struct branch*)br)->subbranch;
			if(pointer!=NULL){
				out=(long)truewrite(file);
				if(out!=0){
					out=(long)save_branch(pointer,file);
				};
			}else{
				out=(long)falsewrite(file);
			};
		};
	};
	return out;
};
//read
void      lowread(unsigned long file,unsigned long buf,unsigned char sz){
	fread(buf,sz,1,file);
};
long*     mediumread(unsigned long file,unsigned short sz){//1
	unsigned long mem;mem=(long)malloc(sz);
	if(mem!=NULL){
		fread(mem,sz,1,file);
	};
	return mem;
};
long*     highread(unsigned long file,unsigned int sz){//1
	unsigned long mem;mem=(long)malloc(sz);
	if(mem!=NULL){
		fread(mem,sz,1,file);
	};
	return mem;
};
void      cread(unsigned long file,unsigned char* pn){
	lowread(file,pn,BYTE);
};
void      sread(unsigned long file,unsigned short* pn){
	lowread(file,pn,WORD);
};
void      iread(unsigned long file,unsigned int* pn){
	lowread(file,pn,DWORD);
};
void      restore_strings_free(unsigned long constpool,unsigned long* strs,unsigned int size){
	if(size!=0){//not always having strings
		long* cursor;cursor=(long)strs;
		unsigned long end;end=(long)strs;
		end=(long)end+(long)size;
		while(cursor!=end){
			free(cursor[0]);
			cursor++;
		};
		free(strs);
		free(constpool);
	};
};
void      restore_branch_inners_free(unsigned long br){
	long* cursor;cursor=(long)((struct branch*)br)->innerbranches;
	unsigned long end;end=(long)cursor;
	end=(long)end+(long)((struct branch*)br)->isize;
	while(cursor!=end){
		restore_branch_free(cursor[0]);
		cursor++;
	};
};
void      restore_branch_cuts_free(unsigned long br){
	unsigned long cursor;cursor=(long)((struct branch*)br)->cuts;
	unsigned long end;end=(long)cursor;
	end=(long)end+(long)((struct branch*)br)->size;
	while(cursor!=end){
		free(((struct branchcut*)cursor)->x);
		cursor=(long)cursor+(long)sizeof(struct branchcut);
	};
	free(((struct branch*)br)->cuts);
};
void      restore_branch_free(unsigned long br){
	restore_branch_cuts_free(br);
	restore_branch_inners_free(br);
	unsigned long sbr;sbr=(long)((struct branch*)br)->subbranch;
	if(sbr!=NULL){
		restore_branch_free(sbr);
	};
	free(br);
};
void      restore_frame_free(unsigned long fr){
	restore_strings_free(((struct preframe*)fr)->restore_ustrings,((struct preframe*)fr)->ustrings,((struct preframe*)fr)->ussize);
	restore_strings_free(((struct preframe*)fr)->restore_dstrings,((struct preframe*)fr)->strings,((struct preframe*)fr)->ssize);
	restore_branch_free(((struct preframe*)fr)->abranch);
};
void      restore_free(unsigned long* predata){
	unsigned long* pss;pss=(long)((struct preoadata*)predata)->presprites;
	unsigned long end;end=(long)pss;
	end=(long)end+(long)((struct preoadata*)predata)->size;
	while(pss!=end){
		unsigned long ps;ps=(long)pss[0];
		if(((struct presprite*)ps)->apreframe!=NULL){
			restore_frame_free(((struct presprite*)ps)->apreframe);
		};
		unsigned long fs;fs=(long)((struct presprite*)ps)->preframes;
		long* f;f=(long)fs;
		unsigned long fend;fend=(long)f;
		fend=(long)fend+(long)((struct presprite*)ps)->size;
		while(f!=fend){
			if(f[0]!=NULL){//can be also showframe
				restore_frame_free(f[0]);
			};
			f++;
		};
		free(fs);
		free(ps);
		pss++;
	};
	free(((struct preoadata*)predata)->presprites);
	free(predata);
};
long*     restore(unsigned long file){//1
	unsigned long data;data=(long)malloc(sizeof(struct preoadata));
	if(data!=NULL){
		unsigned long* presprites;presprites=(long)malloc(sprites_realloc_onepart);
		if(presprites!=NULL){
			((struct preoadata*)data)->presprites=(long)presprites;
			((struct preoadata*)data)->size=(long)0;
			unsigned short size;
			sread(file,&size);
			unsigned char log;log=(long)global_blog();
			if(log==TRUE){
				printf("%hu sprites to restore",size);
				print_inline_done();
			};
			while(size!=0){
				unsigned long ps;ps=(long)malloc(sizeof(struct presprite));
				if(ps!=NULL){
					unsigned long fs;fs=(long)malloc(sprites_realloc_onepart);
					if(fs!=NULL){
						unsigned char ok;ok=(long)re_alloc_add(&((struct preoadata*)data)->presprites,&((struct preoadata*)data)->size,ps);
						if(ok==EXIT_SUCCESS){
							((struct presprite*)ps)->preframes=(long)fs;
							((struct presprite*)ps)->size=(long)0;
							unsigned char bl;
							cread(file,&bl);
							if(bl==TRUE){
								((struct presprite*)ps)->apreframe=(long)restore_frame(file);
								if(((struct presprite*)ps)->apreframe==NULL){
									restore_free(data);
									return NULL;
								};
							}else{
								((struct presprite*)ps)->apreframe=(long)NULL;
							};
							unsigned short frames;sread(file,&frames);
							while(frames!=0){
								cread(file,&bl);
								if(bl==TRUE){
									while(1){
										unsigned long mem;
										mem=(long)restore_frame(file);
										if(mem!=NULL){
											ok=(long)re_alloc_add(&((struct presprite*)ps)->preframes,&((struct presprite*)ps)->size,mem);
											if(ok==EXIT_SUCCESS){
												break;
											};
											free(mem);
										};
										restore_free(data);
										return NULL;
									};
								}else{
									ok=(long)re_alloc_add(&((struct presprite*)ps)->preframes,&((struct presprite*)ps)->size,NULL);
									if(ok==EXIT_FAILURE){
										restore_free(data);
										return NULL;
									};
								};
								frames--;
							};
							size--;
							continue;
						};
						free(fs);
					};
					free(ps);
				};
				restore_free(data);
				return NULL;
			};
			return data;
		};
		free(data);
	};
	return NULL;
};
long*     restore_frame(unsigned long file){//1
	unsigned long f;f=(long)malloc(sizeof(struct preframe));
	if(f!=NULL){
		while(1){
			unsigned short usize;
			usize=(long)restore_strings(file,&((struct preframe*)f)->restore_ustrings,&((struct preframe*)f)->ustrings,&((struct preframe*)f)->ussize);
			if(usize!=0){
				if(((struct preframe*)f)->ussize==0){
					break;
				};
			};
			while(1){
				unsigned short dsize;
				dsize=(long)restore_strings(file,&((struct preframe*)f)->restore_dstrings,&((struct preframe*)f)->strings,&((struct preframe*)f)->ssize);
				if(dsize!=0){
					if(((struct preframe*)f)->ssize==0){
						break;
					};
				};
				unsigned long mem;mem=(long)restore_branch(file);
				if(mem!=NULL){
					((struct preframe*)f)->abranch=(long)mem;
					return f;
				};
				if(dsize!=0){
					restore_strings_free(((struct preframe*)f)->restore_dstrings,((struct preframe*)f)->strings,((struct preframe*)f)->ssize);//inside comparation is extra in extra, but in flow is a saving
				};
				break;
			};
			if(usize!=0){
				restore_strings_free(((struct preframe*)f)->restore_ustrings,((struct preframe*)f)->ustrings,((struct preframe*)f)->ussize);
			};
			break;
		};
		free(f);
	};
	return NULL;
};
long*     restore_strings(unsigned long file,unsigned long* _constpool,unsigned long* _strs,int* _size){
	_size[0]=(long)0;
	unsigned short cpsize;
	sread(file,&cpsize);
	if(cpsize!=0){
		_constpool[0]=(long)mediumread(file,cpsize);
		unsigned long mem;mem=(long)_constpool[0];
		if(mem!=NULL){
			unsigned long start;start=(long)mem;
			_strs[0]=(long)malloc(sprites_realloc_onepart);
			if(_strs[0]!=NULL){
				unsigned long end;end=(long)mem;
				end=(long)end+(long)cpsize;
				while(mem!=end){
					unsigned long s;s=(long)malloc(sizeof(struct ustring));
					if(s!=NULL){
						unsigned char ok;ok=(long)re_alloc_add(_strs,_size,s);
						if(ok==EXIT_SUCCESS){
							((struct ustring*)s)->base=(long)start;
							((struct ustring*)s)->off=(long)mem;
							((struct ustring*)s)->off=(long)((struct ustring*)s)->off-(long)start;
							mem=(long)mem+(long)strlen(mem);
							mem++;//null end
							continue;
						};
						free(s);
					};
					restore_strings_free(start,_strs[0],_size[0]);
					_size[0]=(long)0;
					free(start);
					break;
				};
				return cpsize;
			};
			free(start);
		};
	};
	return cpsize;
};
long*     restore_branch(unsigned long file){//1
	unsigned long br;br=(long)malloc(sizeof(struct branch));
	if(br!=NULL){
		unsigned long mem;
		unsigned int size;
		((struct branch*)br)->cuts=(long)malloc(1);//same as original. is still a mem take, will need it later
		if(((struct branch*)br)->cuts!=NULL){
			((struct branch*)br)->size=(long)0;
			long sz;sz=(long)0;
			while(1){
				iread(file,&size);
				if(size==0){
					break;
				};
				mem=(long)highread(file,size);
				if(mem!=NULL){
					sz=(long)sz+(long)sizeof(struct branchcut);
					unsigned long remem;remem=(long)realloc(((struct branch*)br)->cuts,sz);
					if(remem!=NULL){
						((struct branch*)br)->cuts=(long)remem;
						remem=(long)remem+(long)((struct branch*)br)->size;
						((struct branchcut*)remem)->x=(long)mem;
						((struct branchcut*)remem)->size=(long)size;
						((struct branch*)br)->size=(long)sz;
						continue;
					};
					free(mem);
				};
				restore_branch_cuts_free(br);
				free(br);
				return NULL;
			};
			((struct branch*)br)->innerbranches=(long)malloc(sprites_realloc_onepart);
			if(((struct branch*)br)->innerbranches!=NULL){
				((struct branch*)br)->isize=(long)0;
				iread(file,&size);
				while(size!=0){//inners
					mem=(long)restore_branch(file);
					if(mem!=NULL){
						unsigned char ok;ok=(long)re_alloc_add(&((struct branch*)br)->innerbranches,&((struct branch*)br)->isize,mem);
						if(ok==EXIT_SUCCESS){
							size--;
							continue;
						};
						restore_branch_free(mem);
					};
					restore_branch_cuts_free(br);
					restore_branch_inners_free(br);
					free(br);
					return NULL;
				};
				unsigned char bl;
				cread(file,&bl);
				if(bl==TRUE){//subbranch
					((struct branch*)br)->subbranch=(long)restore_branch(file);
					if(((struct branch*)br)->subbranch!=NULL){
						return br;
					};
					restore_branch_free(br);
					return NULL;
				};
				((struct branch*)br)->subbranch=(long)NULL;
				return br;
			};
			restore_branch_cuts_free(br);
		};
		free(br);
	};
	return NULL;
};
